=== debian/changelog ===
rudiments (1.4.2-1) unstable; urgency=medium

  * Initial release

 -- David Muse <david.muse@firstworks.com>  Thu, 03 Jan 2019 20:32:59 -0500
