=== debian/control ===
Source: rudiments
Priority: optional
Maintainer: David Muse <david.muse@firstworks.com>
Homepage: http://rudiments.sourceforge.net
Standards-Version: 3.9.6
Build-Depends: debhelper (>=9),autotools-dev, libedit-dev, libssl-dev, libcurl4-openssl-dev, libkrb5-dev

Package: rudiments
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libedit2, openssl, libcurl4, libkrb5-3
Description: C++ class library for developing systems and applications
 A C++ class library for developing systems and applications.  Rudiments
 includes frameworks for processes, threads, clients, servers, loggers and
 compilers.  It also includes data structures for buffers, arrays, linked lists
 and dictionaries, and utility classes for processing text and binary data,
 regular expressions, random numbers, encryption, date and time, system
 information, files, directories, file-systems, inter-process communication,
 dynamic libraries, and XML.

Package: rudiments-dev
Section: libdevel
Architecture: any
Depends: rudiments (= ${binary:Version}), ${misc:Depends}
Description: Development files for rudiments
 Development files for rudiments.

Package: rudiments-doc
Section: libs
Architecture: any
Depends: ${misc:Depends}
Description: Documentation for rudiments
 Documentation for rudiments.
