=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	DISTBUILDDEPENDS = -Vdist:BuildDepends="libssl-dev"
else
	DISTBUILDDEPENDS = -Vdist:BuildDepends="libssl1.0-dev"
endif


clean:
	dh_testdir
	dh_auto_configure
	dh_auto_clean
	dh_clean

%:
	dh $@  --with autotools_dev
